Class fplay
ej
java.lang.Object
com.cycling74.max.MaxObject
ej.ej
ej.fplay

public class fplay
extends ej
Multi function editor (like ej.function.js without the graphics)
See Also:

  "ej.function.js"

Fields inherited from class com.cycling74.max.MaxObject
EMPTY_STRING_ARRAY, NO_INLETS, NO_OUTLETS

Constructor Summary
fplay(com.cycling74.max.Atom[] args) create a fplay object

Method Summary
void | addfunction() Method used to add a bpf to the object, then send the names of the bpf to the dumpout outlet in u(bu)menu format
void | addfunction(String s) Method used to add a bpf to the object, then send the names of the bpf to the dumpout outlet in u(bu)menu format
void | addpoints(double[] val) Fast method to add points
void | all(com.cycling74.max.Atom[] args) Send a message to eveery bpf
void | anything(String s, com.cycling74.max.Atom[] args) Look at any message to know if it's a name of a bpf, or a method's name of this ej.fplay object
void | autodomain() Change the domain depending on the position of the first and last points (lowest and highest x value)
void | autorange() Change the range depending on the position of the first and last points (lowest and highest y value)
void | bang() Output all breakpoints of the current function in line format (initial value followed by a list of deltatime-value pairs)
void | clear() Remove all the points of the current bpf
void | clear(int[] idx) Remove the specified points
void | clearsustain() Remove the sustain state of every point of the current bpf
void | dblclick() Display functions informations when you double click on the object
void | deletefunction(int i) Delete a bpf, then send the names of the bpf to the dumpout outlet in u(bu)menu format
void | deletefunction(String s) Delete a bpf, then send the names of the bpf to the dumpout outlet in u(bu)menu format
void | display(int idx) Change the current bpf to...
void | display(String s) Change the current bpf to...
void | domain(double max) Change the domain (x axis) dimensions
void | domain(double min, double max) Change the domain (x axis) dimensions
void | domainAndRange(com.cycling74.max.Atom[] args) used internally...
void | dump() send all points to the dump outlet as pair of x y
void | dump(String s) Send all points to a receive object as pair of x y
void | dumpmatrix() Send all points to the dump outlet as a Jitter Matrix (1 plane, 2 dim, type float32)
void | dumpmatrix(String s) Send all points to a receive object as a Jitter Matrix (1 plane, 2 dim, type float32)
void | fix(int idx, int state) Prevents the user from moving a point.
void | flip() flip the function on both axis
void | flip_x() flip the function on the x axis
void | flip_y() flip the function on the y axis
void | fswitch() Change the current function to the next one availlable, then send a message to the dumpout outlet.
void | getcurrent() Send the current function name to the dumpout outlet.
void | getdisplay() Send the function index to the dumpout outlet.
void | getdomain() Send the range limits of the current function to the dumpout outlet.
void | getfix() Get the list of the fixed points of the current function to the dumpout outlet.
void | getname() Send the name of the functions to the dumpout outlet (in umenu format).
void | getnbpoints() Send the number of point of the current function to the dumpout outlet.
void | getrange() Send the domain limits of the current function to the dumpout outlet.
void | getsustain() Get the list of the sustained points of the current function to the dumpout outlet.
void | inlet(float f) Send the interpolated y for this x for the current function at left outlet
void | inlet(int i) Send the interpolated y for this x for the current function at left outlet
void | insertfunction() inert a bpf at the current location, then send the names of the bpf to the dumpout outlet in u(bu)menu format
void | insertfunction(String s) insert a bpf at the current location, then send the names of the bpf to the dumpout outlet in u(bu)menu format
void | jit_matrix(String s) Set points from a Jitter matrix.
void | list(float[] args) Add or move a point
void | listdump() Send all points to the dump outlet as an unique list which contains pairs of x y
void | listdump(String s) Send all points to a receive object as an unique list which contains paris of x y
void | name(String name) Change the name of the current bpf.
void | name(String[] names) Change the names of the functions
void | next() The next message continues a list output from the sustain point where the output of the last bang or next message ended.
void | normalize() Normalize all the points of the current function.
void | normalize_x() Normalize points of the current function depending on the domain.
void | normalize_y() Normalize points of the current function depending on the range.
void | nth(int i) Send the y value of the point (index) to the leftmost outlet.
void | range(double min, double max) Change the range (y axis) dimensions
void | read() Display a dialog box to select the file to read.
void | read(String s) Attempt to read a text file
void | redrawoff() Does nothing, it's just here for compatibility reasons...
void | redrawon() Does nothing, it's just here for compatibility reasons...
void | removeduplicate() Delete every contigus points with the same y value.
void | save() used internaly...
void | setdomain(double max) change the domain (change the point's values to fit the domain)
void | setdomain(double min, double max) change the domain (change the point's values to fit the domain)
void | setrange(double min, double max) change the range (change the point's values to fit the range)
void | smooth() Smooth the y values with the neighboors...
void | sustain(int idx, int state) Set the sustain state of the point index
void | sync() Send to the dump outlet every informations to synchronize the contents of this ej.fplay with another object like ej.fplay or ej.function.js.
void | sync(String sendName) Send to a receive object every information to synchronize the contents of this ej.fplay with another object like ej.fplay or ej.function.js.
void | synccurrent() Send to the dump outlet every informations to synchronize the current function.
void | synccurrent(String sendName) Send to a receive object every informations to synchronize the current function.
void | syncfunctions(com.cycling74.max.Atom[] args) Message used for the synchronisation.
void | syncpoints(double[] val) Message used for the synchronisation.
void | unfix() Set the fix state of every points of the current function to false
void | write() Display a dialog box to write the contents of the object as a text file.
void | write(String s) Write the contents of the objects as a text file

Methods inherited from class ej.ej
findVersion, isNumber, list, post, post, post, post, post, post

Methods inherited from class com.cycling74.max.MaxObject
bail, createInfoOutlet, declareAttribute, declareAttribute, declareInlets, declareIO, declareOutlets, declareReadOnlyAttribute, declareReadOnlyAttribute, declareTypedIO, embedMessage, error, gc, getAttr, getAttrAtomArray, getAttrBool, getAttrBoolArray, getAttrByte, getAttrByteArray, getAttrChar, getAttrCharArray, getAttrDouble, getAttrDoubleArray, getAttrFloat, getAttrFloatArray, getAttributeInfo, getAttrInt, getAttrIntArray, getAttrLongArray, getAttrShort, getAttrShortArray, getAttrString, getAttrStringArray, getCodeSourcePath, getContext, getErrorStream, getInfoIdx, getInlet, getInletAssist, getInletType, getLongAttr, getMaxBox, getName, getNumInlets, getNumOutlets, getOutletAssist, getOutletType, getParentPatcher, getPostStream, list, loadbang, notifyDeleted, ouch, outlet, outlet, outlet, outlet, outlet, outlet, outlet, outlet, outlet, outlet, outlet, outlet, outlet, outlet, outlet, outlet, outlet, outlet, outlet, outlet, outlet, outlet, outlet, outlet, outlet, outlet, outlet, outlet, outlet, outlet, outlet, outlet, outlet, outlet, outlet, outlet, outlet, outlet, outlet, outlet, outletBang, outletBangHigh, outletHigh, outletHigh, outletHigh, outletHigh, outletHigh, outletHigh, outletHigh, outletHigh, outletHigh, outletHigh, post, postCodePath, setAttr, setAttr, setAttr, setAttr, setAttr, setAttr, setAttr, setAttr, setAttr, setAttr, setAttr, setAttr, setAttr, setAttr, setAttr, setAttr, setAttr, setAttr, setAttr, setAttr, setAttr, setInletAssist, setInletAssist, setName, setOutletAssist, setOutletAssist, showException, showException, toString, viewsource, zap

Methods inherited from class java.lang.Object
clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait

Constructor Detail
fplay
public fplay(com.cycling74.max.Atom[] args)

  create a fplay object
  Parameters:
    args - optional an int specify the number of functions

Method Detail
dblclick
public void dblclick()

  Display functions informations when you double click on the object
  Overrides:
    dblclick in class ej

bang
public void bang()

  Output all breakpoints of the current function in line format (initial value followed by a list of deltatime-value pairs)
  Overrides:
    bang in class ej

inlet
public void inlet(int i)

  Send the interpolated y for this x for the current function at left outlet
  Overrides:
    inlet in class ej
  Parameters:
    i - X value

inlet
public void inlet(float f)

  Send the interpolated y for this x for the current function at left outlet
  Overrides:
    inlet in class ej
  Parameters:
    f - X value

list
public void list(float[] args)

  Add or move a point
  Overrides:
    list in class com.cycling74.max.MaxObject
  Parameters:
    args -
    2 elements (x, y): add the new point at the location x y
    3 elements (idx, x, y): move the point idx to the location x y. idx starts at 0.

anything
public void anything(String s,
com.cycling74.max.Atom[] args)

  Look at any message to know if it's a name of a bpf, or a method's name of this ej.fplay object
  Overrides:
    anything in class ej

all
public void all(com.cycling74.max.Atom[] args)

  Send a message to eveery bpf
  Parameters:
    args - quite any message

addfunction
public void addfunction()

  Method used to add a bpf to the object, then send the names of the bpf to the dumpout outlet in u(bu)menu format

addfunction
public void addfunction(String s)

  Method used to add a bpf to the object, then send the names of the bpf to the dumpout outlet in u(bu)menu format
  Parameters:
    s - name of the bpf

insertfunction
public void insertfunction()

  inert a bpf at the current location, then send the names of the bpf to the dumpout outlet in u(bu)menu format

insertfunction
public void insertfunction(String s)

  insert a bpf at the current location, then send the names of the bpf to the dumpout outlet in u(bu)menu format
  Parameters:
    s - name of the bpf

deletefunction
public void deletefunction(int i)

  Delete a bpf, then send the names of the bpf to the dumpout outlet in u(bu)menu format
  Parameters:
    i - bpf index (start at 0)

deletefunction
public void deletefunction(String s)

  Delete a bpf, then send the names of the bpf to the dumpout outlet in u(bu)menu format
  Parameters:
    s - bfp name

addpoints
public void addpoints(double[] val)

  Fast method to add points
  Parameters:
    val - list of pairs x y

jit_matrix
public void jit_matrix(String s)

  Set points from a Jitter matrix.
  Parameters:
    s - matrix name (~ address)

read
public void read()

  Display a dialog box to select the file to read.

read
public void read(String s)

  Attempt to read a text file
  Parameters:
    s - file name (if in search path), or file path

write
public void write()

  Display a dialog box to write the contents of the object as a text file.

write
public void write(String s)

  Write the contents of the objects as a text file
  Parameters:
    s - file name (if in the search path), file path

fswitch
public void fswitch()

  Change the current function to the next one availlable, then send a message to the dumpout outlet.

display
public void display(int idx)

  Change the current bpf to...
  Parameters:
    idx - index of the new current bpf

display
public void display(String s)

  Change the current bpf to...
  Parameters:
    s - name of the new current bpf

nth
public void nth(int i)

  Send the y value of the point (index) to the leftmost outlet.
  Parameters:
    i - index of the point

next
public void next()

  The next message continues a list output from the sustain point where the output of the last bang or next message ended.

dump
public void dump()

  send all points to the dump outlet as pair of x y

listdump
public void listdump()

  Send all points to the dump outlet as an unique list which contains pairs of x y

dumpmatrix
public void dumpmatrix()

  Send all points to the dump outlet as a Jitter Matrix (1 plane, 2 dim, type float32)

dump
public void dump(String s)

  Send all points to a receive object as pair of x y
  Parameters:
    s - name of the receive object you want to send it to.

listdump
public void listdump(String s)

  Send all points to a receive object as an unique list which contains paris of x y
  Parameters:
    s - name of the receive object you want to send it to.

dumpmatrix
public void dumpmatrix(String s)

  Send all points to a receive object as a Jitter Matrix (1 plane, 2 dim, type float32)
  Parameters:
    s - name of the receive object you want to send it to.

clear
public void clear()

  Remove all the points of the current bpf

clear
public void clear(int[] idx)

  Remove the specified points
  Parameters:
    idx - index (starting at 0) of the points of the current bpf to be deleted

name
public void name(String name)

  Change the name of the current bpf.
  Parameters:
    name - new name for the function

name
public void name(String[] names)

  Change the names of the functions
  Parameters:
    names - names of the functions

domain
public void domain(double max)

  Change the domain (x axis) dimensions
  Parameters:
    max - maximum value (minimum will be 0)

domain
public void domain(double min,
double max)

  Change the domain (x axis) dimensions
  Parameters:
    min - minimum value
    max - maximum value

range
public void range(double min,
double max)

  Change the range (y axis) dimensions
  Parameters:
    min - minimum value
    max - maximum value

setdomain
public void setdomain(double max)

  change the domain (change the point's values to fit the domain)
  Parameters:
    max - domain maximum value (minimum will be 0)

setdomain
public void setdomain(double min,
double max)

  change the domain (change the point's values to fit the domain)
  Parameters:
    min - domain minimum value
    max - domain maximum value

setrange
public void setrange(double min,
double max)

  change the range (change the point's values to fit the range)
  Parameters:
    min - range minimum value
    max - range maximum value

autodomain
public void autodomain()

  Change the domain depending on the position of the first and last points (lowest and highest x value)

autorange
public void autorange()

  Change the range depending on the position of the first and last points (lowest and highest y value)

normalize
public void normalize()

  Normalize all the points of the current function. This will strech the points to Òfill" the domain and the range.

normalize_x
public void normalize_x()

  Normalize points of the current function depending on the domain. This will strech the points to Òfill" the domain.

normalize_y
public void normalize_y()

  Normalize points of the current function depending on the range. This will strech the points to Òfill" the range.

flip
public void flip()

  flip the function on both axis

flip_x
public void flip_x()

  flip the function on the x axis

flip_y
public void flip_y()

  flip the function on the y axis

removeduplicate
public void removeduplicate()

  Delete every contigus points with the same y value.

smooth
public void smooth()

  Smooth the y values with the neighboors...

sustain
public void sustain(int idx,
int state)

  Set the sustain state of the point index
  Parameters:
    idx - number of the point (starting at 0)
    state - 1 if the point is sustained, 0 otherwise.

fix
public void fix(int idx,
int state)

  Prevents the user from moving a point.
  Parameters:
    idx - index of the point (starting at 0)
    state - 1 for fix, 0 for unfix

getname
public void getname()

  Send the name of the functions to the dumpout outlet (in umenu format).

getdomain
public void getdomain()

  Send the range limits of the current function to the dumpout outlet.

getrange
public void getrange()

  Send the domain limits of the current function to the dumpout outlet.

getcurrent
public void getcurrent()

  Send the current function name to the dumpout outlet.

getdisplay
public void getdisplay()

  Send the function index to the dumpout outlet.

getsustain
public void getsustain()

  Get the list of the sustained points of the current function to the dumpout outlet.

getfix
public void getfix()

  Get the list of the fixed points of the current function to the dumpout outlet.

clearsustain
public void clearsustain()

  Remove the sustain state of every point of the current bpf

unfix
public void unfix()

  Set the fix state of every points of the current function to false

getnbpoints
public void getnbpoints()

  Send the number of point of the current function to the dumpout outlet.

sync
public void sync()

  Send to the dump outlet every informations to synchronize the contents of this ej.fplay with another object like ej.fplay or ej.function.js.

synccurrent
public void synccurrent()

  Send to the dump outlet every informations to synchronize the current function.

sync
public void sync(String sendName)

  Send to a receive object every information to synchronize the contents of this ej.fplay with another object like ej.fplay or ej.function.js.
  Parameters:
    sendName - name of the receive object you'll send the values to

synccurrent
public void synccurrent(String sendName)

  Send to a receive object every informations to synchronize the current function.
  Parameters:
    sendName - name of the receive object you'll send the values to

syncfunctions
public void syncfunctions(com.cycling74.max.Atom[] args)

  Message used for the synchronisation.
  Parameters:
    args - [function index] [function name] domain and range

syncpoints
public void syncpoints(double[] val)

  Message used for the synchronisation.
  Parameters:
    val - [function index] [val_x val_y state]*

save
public void save()

  used internaly... to store parameters in the patch.
  Overrides:
    save in class com.cycling74.max.MaxObject

domainAndRange
public void domainAndRange(com.cycling74.max.Atom[] args)

  used internally... don't use it!

redrawon
public void redrawon()

  Does nothing, it's just here for compatibility reasons...

redrawoff
public void redrawoff()

  Does nothing, it's just here for compatibility reasons...

Java API documentation generated with DocFlex/Doclet v1.6.0
DocFlex/Doclet is both a multi-format Javadoc doclet and a free edition of DocFlex/Javadoc. If you need to customize your Javadoc without writing a full-blown doclet from scratch, DocFlex/Javadoc may be the only tool able to help you! Find out more at www.docflex.com